# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus_client.com.termlex.pathnexus.model.i_base_coding import IBaseCoding  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.i_primitive_type_string import IPrimitiveTypeString  # noqa: F401,E501


class IBaseMetaType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'version_id': 'str',
        'profile': 'list[IPrimitiveTypeString]',
        'security': 'list[IBaseCoding]',
        'tag': 'list[IBaseCoding]',
        'last_updated': 'datetime',
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'empty': 'bool'
    }

    attribute_map = {
        'version_id': 'versionId',
        'profile': 'profile',
        'security': 'security',
        'tag': 'tag',
        'last_updated': 'lastUpdated',
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'empty': 'empty'
    }

    def __init__(self, version_id=None, profile=None, security=None, tag=None, last_updated=None, format_comments_pre=None, format_comments_post=None, empty=None):  # noqa: E501
        """IBaseMetaType - a model defined in Swagger"""  # noqa: E501

        self._version_id = None
        self._profile = None
        self._security = None
        self._tag = None
        self._last_updated = None
        self._format_comments_pre = None
        self._format_comments_post = None
        self._empty = None
        self.discriminator = None

        if version_id is not None:
            self.version_id = version_id
        if profile is not None:
            self.profile = profile
        if security is not None:
            self.security = security
        if tag is not None:
            self.tag = tag
        if last_updated is not None:
            self.last_updated = last_updated
        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if empty is not None:
            self.empty = empty

    @property
    def version_id(self):
        """Gets the version_id of this IBaseMetaType.  # noqa: E501


        :return: The version_id of this IBaseMetaType.  # noqa: E501
        :rtype: str
        """
        return self._version_id

    @version_id.setter
    def version_id(self, version_id):
        """Sets the version_id of this IBaseMetaType.


        :param version_id: The version_id of this IBaseMetaType.  # noqa: E501
        :type: str
        """

        self._version_id = version_id

    @property
    def profile(self):
        """Gets the profile of this IBaseMetaType.  # noqa: E501


        :return: The profile of this IBaseMetaType.  # noqa: E501
        :rtype: list[IPrimitiveTypeString]
        """
        return self._profile

    @profile.setter
    def profile(self, profile):
        """Sets the profile of this IBaseMetaType.


        :param profile: The profile of this IBaseMetaType.  # noqa: E501
        :type: list[IPrimitiveTypeString]
        """

        self._profile = profile

    @property
    def security(self):
        """Gets the security of this IBaseMetaType.  # noqa: E501


        :return: The security of this IBaseMetaType.  # noqa: E501
        :rtype: list[IBaseCoding]
        """
        return self._security

    @security.setter
    def security(self, security):
        """Sets the security of this IBaseMetaType.


        :param security: The security of this IBaseMetaType.  # noqa: E501
        :type: list[IBaseCoding]
        """

        self._security = security

    @property
    def tag(self):
        """Gets the tag of this IBaseMetaType.  # noqa: E501


        :return: The tag of this IBaseMetaType.  # noqa: E501
        :rtype: list[IBaseCoding]
        """
        return self._tag

    @tag.setter
    def tag(self, tag):
        """Sets the tag of this IBaseMetaType.


        :param tag: The tag of this IBaseMetaType.  # noqa: E501
        :type: list[IBaseCoding]
        """

        self._tag = tag

    @property
    def last_updated(self):
        """Gets the last_updated of this IBaseMetaType.  # noqa: E501


        :return: The last_updated of this IBaseMetaType.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this IBaseMetaType.


        :param last_updated: The last_updated of this IBaseMetaType.  # noqa: E501
        :type: datetime
        """

        self._last_updated = last_updated

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this IBaseMetaType.  # noqa: E501


        :return: The format_comments_pre of this IBaseMetaType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this IBaseMetaType.


        :param format_comments_pre: The format_comments_pre of this IBaseMetaType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this IBaseMetaType.  # noqa: E501


        :return: The format_comments_post of this IBaseMetaType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this IBaseMetaType.


        :param format_comments_post: The format_comments_post of this IBaseMetaType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def empty(self):
        """Gets the empty of this IBaseMetaType.  # noqa: E501


        :return: The empty of this IBaseMetaType.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this IBaseMetaType.


        :param empty: The empty of this IBaseMetaType.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IBaseMetaType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
